<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Dropbox_api extends CI_Controller {
    
    public function index(){
        echo 'We are here..';
    }   
    
// 	public function access_token(){
// 	    $redirect_uri = (base_url('DropBox/dropbox'));
//         $test = "https://www.dropbox.com/oauth2/authorize?client_id=65gkbwmeqgf9h4b&response_type=code&redirect_uri={$redirect_uri}";
//         header('Location: '.$test);
// 	   // echo"<pre>";print_r($token);die;
// 	}
	
	public function authrization(){
	    if (isset($_GET['code'])) {
            $code = $_GET['code'];    
            $this->load->library('Dropbox_libraries'); 
            $result = $this->dropbox_libraries->getAccesToken($code);
            $res = json_decode( $result, true );
            if(isset($res['access_token'])){
                $userInfo = $this->dropbox_libraries->getUserDetails($res['account_id'], $res['access_token']);
                $userSpaceUsage = $this->dropbox_libraries->getSpaceUsage($res['access_token']);
                $userSpace = json_decode( $userSpaceUsage, true );
                $totalSpace = $userSpace['allocation']['allocated'];
                $usedSpace = $userSpace['used'];
               
                // echo"<pre>";print_r($userInfo);die;
                $userInfo = json_decode( $userInfo, true );
                $userInfo['usedSpace'] = $usedSpace;
                $userInfo['totalSpace'] = $totalSpace;
                if(isset($userInfo)){
                    $data = array(
                        'user_id' => $_SESSION['id'],
                        'email' => $userInfo['email'],
                        'access_token' => $result,
                        'user_info' => json_encode( $userInfo ),
                        'status' => 1,
                        'connection_type' =>'DropBox'
                    );
                    $checkValue = $this->DBfile->get_data('connection',array('user_id'=>$this->session->userdata['id'],'email'=>$userInfo['email'],'connection_type'=>'DropBox'));
                    if(!empty($checkValue)){
                        $data = array(
                            'email' => $userInfo['email'],
                            'access_token' => $result,
                            'user_info' => json_encode( $userInfo ),
                            'status' => 1
                        );
                        
                        $result = $this->DBfile->set_data( 'connection', $data , array('user_id'=>$this->session->userdata['id'],'email'=>$userInfo['email'],'connection_type'=>'DropBox'));
                        if($result==true){
                             redirect( 'home/dashboard', 'refresh' );
                        }else{
                             redirect( 'home/connection', 'refresh' );
                        }
                    }else{
                        $result = $this->DBfile->put_data('connection',$data);
                        if($result==true){
                             redirect( 'home/dashboard', 'refresh' );
                        }else{
                             redirect( 'home/connection', 'refresh' );
                        }
                   }
                }
                echo"<pre>";print_r($userInfo);die;
            }
        }
	}
	
	public function formatBytes($bytes) {
        if ($bytes > 0) {
            $i = floor(log($bytes) / log(1024));
            $sizes = array('B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
            return sprintf('%.02F', round($bytes / pow(1024, $i),1)) * 1 . ' ' . @$sizes[$i];
        } else {
            return 0;
        }
    }
	
	
        
	public function dropbox(){
	    echo"<pre>";print_r($_GET);die;
	    $apiKey = '65gkbwmeqgf9h4b';
	    $secretKey = '3ck1slo190rp9xy';
        if($_GET['code'] != ''){
            
    	    $code = $_GET['code'];
    	    
    	    $url = urlencode(base_url('test/dropbox'));
            // Generated by curl-to-PHP: http://incarnate.github.io/curl-to-php/
            $ch = curl_init();
    
            curl_setopt($ch, CURLOPT_URL, 'https://api.dropbox.com/oauth2/token');
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, "code={$code}&grant_type=authorization_code&redirect_uri={$url}");
            curl_setopt($ch, CURLOPT_USERPWD, $apiKey . ':' . $secretKey);
    
            $headers = array();
            $headers[] = 'Content-Type: application/x-www-form-urlencoded';
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    
            $result = curl_exec($ch);
            if (curl_errno($ch)) {
                echo 'Error:' . curl_error($ch);
            }
            curl_close($ch);
            $r = json_decode( $result, true );
            echo"<pre>";print_r($r);die;
            return $result;
        }else{
            $redirect_uri = base_url('test/dropbox');
            $test = "https://www.dropbox.com/oauth2/authorize?client_id=".$apiKey."&response_type=code&redirect_uri={$redirect_uri}";
            header('Location: '.$test);
        }
	}
	
	public function createFolder(){
	    $accessToken = 'sl.BQnPtyK-No5OreQbwazfikucjpOIwftxcj-OMkGhVyVahM1flWYIqCdB7z0h7M6460nkXeH3k_EwNoJUnp0lyaPF0N71w09073mJ-dOQLzjbTEJ-x9bR2QAB0gVlH0mH1unHWHI';
        $folderName = 'test';
	    $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/files/create_folder_v2');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"path\": \"/{$folderName}\",\"autorename\": false}");

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);
        $r = json_decode( $result, true );
        echo"<pre>";print_r($r);die;
        return $result;
	}
	
	public function uploadFileDropbox(){
	    
	    $accessToken = 'sl.BQps5et1HQCq4qyTwoSUF885X1GbV_ZA4fQpn_xGIVEnfZB0dhboxRzDUzHv50DVKae2Dr5KAycZ8F3tKCU1zzjNIPQBkoDxwoJmdG0ajs0WKx6JyicDbLEJj7_hJD03V5RTjJY';
	    $folderName = 'test';
	    $file = $_SERVER["DOCUMENT_ROOT"]."/selfCloud/index.php";
	    
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://content.dropboxapi.com/2/files/upload');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        $post = array(
            'file' => '@'.$file
        );
        curl_setopt($ch, CURLOPT_POSTFIELDS, file_get_contents($file) );
        $name = basename($file);
        $args = array(
            "path" => '/'.$folderName.'/'.$name,
            "mode" => "add"
        );
        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Dropbox-Api-Arg: '. json_encode($args) ;
        $headers[] = 'Content-Type: application/octet-stream';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        $r = json_decode( $result, true );
        echo"<pre>";print_r($r);die;
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return $result;
    }
    
//  	public function uploadFile(){
//  	    $ch = curl_init();

//         curl_setopt($ch, CURLOPT_URL, 'https://content.dropboxapi.com/2/files/upload');
//         curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
//         $post = array(
//             'file' => '@' .realpath('paypal_1.png')
//         );
//         curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
//         curl_setopt($ch, CURLOPT_POST, 1);
        
//         $headers = array();
//         $headers[] = 'Authorization: Bearer sl.BQry3pvgeTyrFUq7_Rqiufz8zeWpCQE9B0UYjRUGTlT4GZPO45b_psT-fSnfNH-CZKohI-TOpPk7b9IPN-nMgHQAIpD6hSY3oy5ANAkMwh6VMaRyaId4Shmk2O9-d8o829IE9Q8l';
//         $headers[] = 'Content-Type: application/octet-stream';
//         $headers[] = 'Dropbox-Api-Arg: {\"path\":\"C:/Users/yash/OneDrive/Desktop/paypal_1.png\",\"mode\":{\".tag\":\"add\"},\"autorename\":false,\"mute\":false,\"strict_conflict\":false}';
//         curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        
//         $result = curl_exec($ch);
//         $r = json_decode( $result, true );
//         echo"<pre>";print_r($result);die;
//         if (curl_errno($ch)) {
//             echo 'Error:' . curl_error($ch);
//         }
//         curl_close ($ch);
 	    
//  	}

    public function deleteFile(){
        $accessToken = 'sl.BQps5et1HQCq4qyTwoSUF885X1GbV_ZA4fQpn_xGIVEnfZB0dhboxRzDUzHv50DVKae2Dr5KAycZ8F3tKCU1zzjNIPQBkoDxwoJmdG0ajs0WKx6JyicDbLEJj7_hJD03V5RTjJY';
	   // $folderName = 'test';
	    $path = '/test/index.php';
	    
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/files/delete_v2');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"path\":\"{$path}\"}");

        $headers = array();
        $headers[] = "Authorization: Bearer {$accessToken}";
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        $r = json_decode( $result, true );
        echo"<pre>";print_r($r);die;
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return $result;
    }
    public function get_space_usage(){
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, 'https://api.dropboxapi.com/2/users/get_space_usage');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, "null");
        
        $headers = array();
        $headers[] = 'Authorization: Bearer sl.BQpAOO4jg8OQ4_082XWn5QNZlV8U-mTlO_yVndERTIjgZQ1oGLUhNSnGVnhyPCC6TBUt8BH4aM6ORJdKTQG7Rn_gTHbFmv8ATLziuJclXNTWy9v6kQH_QzrVBgqaaKYaB6G0Jmg';
        $headers[] = 'Content-Type: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        
        $result = curl_exec($ch);
          $r = json_decode( $result, true );
                echo"<pre>";print_r($r);die;
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close ($ch);
        
        return $result;
    }
}